/*
 * Copyright 2013  Samsung Electronics Co., Ltd
 *
 * Licensed under the Flora License, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://floralicense.org/license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

class CModule
{
private:
	static const char *m_sModulePath;
	static struct dlist *m_pModuleList;

	void *m_pHandle;
	void *(*m_fNew)(void);
	char *m_sPkgname;
	struct dlist *m_pList;
	int (*m_fNeedToCreate)(const char *cluster, const char *category);
	int (*m_fInitialize)(const char *pkgname);
	int (*m_fFinalize)(void);

	CModule(char *pkgname) : m_pHandle(NULL), m_fNew(NULL), m_sPkgname(pkgname), m_pList(NULL), m_fNeedToCreate(NULL), m_fInitialize(NULL), m_fFinalize(NULL) {}
	virtual ~CModule() {}

public:
	static CModule *FindModule(const char *pkgname);

	static CModule *Load(const char *pkgname);
	int Unload(void);

	int Create(const char *id, const char *content, const char *cluster, const char *category);
	int NeedToCreate(const char *cluster, const char *category);
	int Destroy(CLiveBoxImpl *inst);

	CLiveBoxImpl *FindLiveBox(const char *id);

	const char *PackageName(void) { return m_sPkgname; }
};

/* End of a file */
