/*
 * Copyright 2013  Samsung Electronics Co., Ltd
 *
 * Licensed under the Flora License, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://floralicense.org/license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifdef __cplusplus
extern "C" {
#endif
extern int livebox_initialize(const char *pkgname);
extern int livebox_finalize(const char *pkgname);

extern int livebox_create(const char *pkgname, const char *filename, const char *content, const char *cluster, const char *category);
extern int livebox_destroy(const char *pkgname, const char *filename);
extern int livebox_need_to_update(const char *pkgname, const char *filename);
extern int livebox_need_to_destroy(const char *pkgname, const char *filename);
extern int livebox_update_content(const char *pkgname, const char *filename);

/*!
 * \param[in] event "clicked" only
 */
extern int livebox_clicked(const char *pkgname, const char *filename, const char *event, double timestamp, double x, double y);

/*!
 * if "source" == "filename", emission could be "pd,show", "pd,hide", "lb,show", "lb,hide".
 */
extern int livebox_content_event(const char *pkgname, const char *filename, const char *emission, const char *source, struct event_info *event_info);
extern int livebox_resize(const char *pkgname, const char *filename, int type);
extern int livebox_change_group(const char *pkgname, const char *filename, const char *cluster, const char *category);
extern int livebox_get_info(const char *pkgname, const char *filename, int *w, int *h, double *priority, char **content, char **title);
extern int livebox_need_to_create(const char *pkgname, const char *cluster, const char *category);
extern char *livebox_pinup(const char *pkgname, const char *filename, int pinup);
extern int livebox_is_pinned_up(const char *pkgname, const char *filename);
extern int livebox_system_event(const char *pkgname, const char *filename, int event);

#ifdef __cplusplus
}
#endif

/* End of a file */
